@echo off
        rem     load palette, font, fill with background pattern
    wbat pal ! font ! fill (+green on yellow) " " +2

        rem ------------------------------------------------------------
        rem     start box using default source file: DEMO.TXT
    wbat box @:start
        rem     El 1: start, 2: exit, 255: error
        if errorlevel 255 echo Error running WBAT box @:start
        if errorlevel 255 pause
        if errorlevel 2 goto exit

        rem     mpos controls current bar position in main menu
        set mpos=0

:main menu =============================================================

    wbat cls ! text 23,8 (+black on +green) @:move_box
    call w.bat menu 4 (black +brown) @:index #%mpos%+1
        rem     keep mpos: bar position=errorlevel
        set mpos=%?%
        set wpos=

        goto %wbat%  (go label = first word of menu item)

:general information ---------------------------------------------------

    wbat cls
        rem     box with buttons that are returned as variables
    call w.bat box @:general #%wpos%+1
        if errorlevel 7 goto main
        set wpos=%?%

        rem     show text according to button name %wbat%
    wbat text 2,4 @:gen_%wbat% ! box 22,68 back
        goto general

:dialog box ------------------------------------------------------------

    wbat cls
    call w.bat box @:dialog_menu #%wpos%
        if %wbat%==back goto main
        set wpos=%?%
        set spos=
        goto %wbat%
        rem     go label according to selected item

:Command ...............................................................

    wbat cls ! text 2,4 @:syntax

:comm_rpt ......... this menu box is always shown on the following pages

    call w.bat menu 25,70 @:command_spec #%spos%
        if errorlevel 100 goto dialog
        if %wbat%==back goto dialog
        set spos=%?%

        rem     show text by label from command_spec menu (prefix: com_)

    wbat cls ! text 2,4 @:com_%wbat%
        goto comm_rpt

:Elements ..............................................................

    wbat cls ! text 2,4 @:layout

:elem_rpt

    call w.bat menu 25,70 @:control_elements #%spos%
        if errorlevel 100 goto dialog
        set spos=%?%
    wbat cls ! text 2,4 @:ctl_%wbat%
        goto elem_rpt

:Style .................................................................

    wbat cls ! text 2,4 @:style

:st_rpt

    call w.bat menu 25,70 @:style_menu #%spos%
        if errorlevel 100 goto dialog
        set spos=%?%
    wbat cls ! text 2,4 @:st_%wbat%
        goto st_rpt


:Handling ..............................................................

    wbat cls ! text 2,4 @:handling

:keys_rpt
    call w.bat menu 25,70 @:keys #%spos%
        if errorlevel 100 goto dialog
        set spos=%?%
    wbat cls ! text 2,4 @:key_%wbat%
        goto keys_rpt

:Variables .............................................................

    wbat cls ! text 2,4 @:variables

:var_rpt
    call w.bat menu 25,70 @:var_menu #%spos%
        if errorlevel 100 goto dialog
        set spos=%?%

    wbat cls ! text 2,4 @:var_%wbat%
rem     if %wbat%==WBAT goto var_rpt
    wbat box 22,65 (white on +blue) more
    wbat cls ! text 2,4 (blue on +green) @:var_%wbat%_cont
        goto var_rpt

:Testing ...............................................................

    call TEST.BAT
        goto dialog

:screen  - text, fill --------------------------------------------------

    wbat cls
    call w.bat box @:screen_menu #%wpos%
        if %wbat%==back goto main
        set wpos=%?%
        set spos=
        goto S_%wbat%

:s_cls    ..............................................................

    wbat cls ! text 2,4 @:cls ! box 21,70 back
        goto screen

:s_ansi?
    wbat ansi?
        if not errorlevel 1 goto s_cont
    wbat cls ! text 2,4 @:no_ansi
    wbat box 21,65 continue,skip
        if errorlevel 2 goto screen
:s_cont
    wbat cls ! text 2,4 @:scr_ansi ! box 21,65 ok
    goto screen

:s_fill ................................................................

    wbat cls ! text 2,4 @:fill

:fill_rpt
    call w.bat menu 25,58 @:fill_commands #%spos%
        if errorlevel 100 goto screen
        set spos=%?%
    wbat cls
        goto f_%wbat%

:f_clear
    wbat text 2,4 @:fill_clear ! fill 20,7 (4,65) (red on +brown)
        goto fill_rpt

:f_strings
    wbat text 2,4 @:fill_strings
    wbat fill 5,55 (3,22) (+white on blue) ""
    wbat fill 9,55 (3,22) (+white on blue) ""
    wbat fill 13,55 (4,22) (+cyan on blue) " Wbat *"
    wbat fill 2,78 (23,1) (+white on blue) ""
        goto fill_rpt

:f_shifting
    wbat text 2,4 @:fill_shift
    wbat fill 7,55 (4,22) (+cyan on red) "Wbat * " +2
    wbat fill 12,55 (3,22) (+cyan on red) ""
    wbat fill 16,55 (5,22) (+cyan on red) "" +2
    wbat fill 2,78 (23,1) (red on yellow) "WBAT*" +1
        goto fill_rpt

:s_cursor  .............................................................

    wbat cls ! text 2,4 @:cursor ! box 21,65 ok
        goto screen

:s_text ................................................................

    wbat cls ! text 2,4 @:text

:text_rpt
    call w.bat menu 25,70 @:txt_menu #%spos%
        if errorlevel 100 goto screen
        set spos=%?%
    wbat cls ! text 2,4 @:txt_%wbat%
        if not %wbat%==display goto text_rpt
    wbat text 19,4  (+ white on red) @:txt_ex1
    wbat text 19,32 (+ white on red) @:txt_ex2
        goto text_rpt

:s_stdout

    wbat cls ! text 2,4 @:stdout ! box 21,65 ok
        goto screen

:color palette and font ------------------------------------------------

    wbat cls
    call w.bat box @:font_pal #%wpos%
        if %wbat%==back goto main
        set wpos=%?%
    wbat cls ! text 2,4 @:style_%wbat% ! box 20,65 ok
        goto color

:test colors -----------------------------------------------------------

    call colors.bat
        goto main

:quick reference -------------------------------------------------------

    wbat cls
    call w.bat menu @:quick_ref #%wpos%
        if %wbat%==back goto main
        set wpos=%?%
    wbat cls! text 2,4 @:ref_%wbat% ! box 22,65 ok
        goto quick

:ini    ----------------------------------------------------------------

    wbat cls
    call w.bat box @:setup #%wpos%
        if %wbat%==back goto main
        set wpos=%?%
        set spos=
        if %wbat%==WBATINI goto ini_WBATINI
    wbat text 2,4 @:ini_%wbat% ! box 22,70 ok
        goto ini

:ini_WBATINI    ........................................................

    wbat cls ! text 2,4 @:ini_WBATINI ! box 25,68 continue
    wbat cls ! text 2,2 (black on white) @WBAT.INI
    wbat box 25,68 OK
    goto ini

:tips   ----------------------------------------------------------------

    wbat cls
    call w.bat menu @:tips_menu #%wpos%
        if %wbat%==back goto main
        set wpos=%?%
    wbat text 2,4 @:tip_%wbat% ! box 25,70 ok
        goto tips

:exit
for %%a in (wbat mpos wpos spos) do set %%a=
set ?=
wbat cls ! box "Reset font and palette?" yes,no
if not errorlevel 2 mode co80
cls
:end
